!- TRIANGULAR uOS 1.29 for Commodore Plus/4
!- UOS


!- Set BASIC variables & launch hardware tests & set memory variables
0print"{home*2}{clear}{ct h}{cyan}{142}":clr:color.,1,.:color4,1,.:q$=chr$(34):v$="1.29":pa=65532:vol.:gosub8:if(fre(.))<56000thenn$="not enough ram!":goto22
1gosub20:gosub24:fm=64:gosub8:gosub9:dd=1:poke998,fm:poke989,dd:poke990,.:poke995,158:poke994,31:poke996,.:poke997,230:poke991,1:poke992,10:poke993,20:bs=peek(910):ifbs<8andbs>11thenbs=8

!- Launch screen
2bi=.:print"{clear}";:gosub8:print"{down*2}{purple}":gosub55:print"{return}"tab(13)"{up}{cm asterisk}{reverse on}            {reverse off}{sh pound}":gosub56:printtab(15)"{up}{cm asterisk}{reverse on}        {reverse off}{sh pound}":gosub56:printtab(17)"{up}{cm asterisk}{reverse on}    {reverse off}{sh pound}":gosub56:printtab(19)"{up}{cm asterisk}{sh pound}":gosub56
3print"{down}{blue}  {cm c}{reverse on}{cm d}{cm k}{reverse off}{cm b}{reverse on}{cm k}{reverse off}{cm d}{cm b}{reverse on}{cm k}{reverse off}{cm f}{cm k}{reverse on}{cm b}{reverse off}{cm v}{cm k*3} {reverse on}{cm b}{reverse off}{cm f}{reverse on}{cm d}{reverse off}{cm f}   {pink}{reverse on}{cm d}{reverse off}{cm k}{reverse on}{cm d}{reverse off}{cm v} {light blue}"v$"{return}{blue}   {cm k}{reverse on}{cm k}{reverse off}{cm b}{reverse on}{cm k*2}{cm f}{cm k}{reverse off}{cm c}{cm k*6} {reverse on}{cm d}{reverse off}{cm k}{reverse on}{cm d}{reverse off}{cm f} {light blue}{cm k*2}{pink}{cm k*2}{reverse on}{cm i}{reverse off}{cm k}{return}{blue}   {cm v}{cm c*6} {cm v}{cm c}{cm v}{reverse on}{cm i}{reverse off}{cm v}{reverse on}{cm i}{reverse off}{cm v*5} {reverse on}{light blue}{cm i}{reverse off}{cm k}{reverse on}{pink}{cm i}{reverse off}{cm v}{reverse on}{cm i}{reverse off}{cm v} ";:color1,2,4:print"(c) 2023"
4gosub8:ifrn=.then75
5printtab(26)"{down*4}{reverse on}{yellow}f1{reverse off} {pink}bios setup";:poke239,.:gosub11
6getk$:ifk$="{f1}"then26

!- Load GUI
7n$="gui":l$=" loading...":print"{purple}";:gosub93:goto94

!- Delay 200 for's
8forj=.to200:nextj:return

!- Beep sound
9vol8:sound1,760,12:forj=.to100:nextj:return

!- Beep sound x3
10gosub9:gosub9:gosub9:return

!- Delay 1000 for's
11fori=.to1000:nexti:return

!- Disk drive tests (drive # evaluatian: 8+di)
12open1,8+di,2:close1:ifst<>.then16
13gosub19:ifen$=""then16
14open1,8+di,15:print#1,"m-r";chr$(51);chr$(255):get#1,d$:t1=asc(d$+chr$(.)):close1:vt$="":open5,8+di,5,"uos.cfg,s,r":input#5,vt$:close5:gosub19:poke971+di,1:poke975+di,t1:bi=1:ifv$=vt$then17
15return
16poke971+di,.:poke975+di,.:return

17bd=8+di:ifbs=bdthent=1
18return

!- Read disk error channel
19open1,8+di,15:input#1,en,en$,tr,sc:close1:return

!- Commodore Plus/4 type confirmation
20poke239,.:poke1319,167:poke1320,189:poke239,2:getk$:geta$:k$=k$+a$:ifk$="{cm m}{cm x}"andpeek(pa)=246andpeek(pa+1)=255then23
21n$="can't run this{cm m}{cm x}os version!"

!- Shut down with error message
22l$="shut down...":print"{red}";:gosub93:print"{home}{red}"n$:gosub8:gosub10:gosub11:goto99

!- Set up initial memory variables
23poke1000,7:restore23:fori=.to5:readj:poke1319+i,j:nexti:fori=1to8:keyi,chr$(i+132):nexti:return:data19,13,82,85,78,13

!- Cursor test & screen mode detection
24print"{clear}{down}{cm p}";:gosub8:ifpeek(3112)=111thenpoke999,40:return
25print"{clear}":gosub8:n$="this graphic mode is not supported!":goto22

!- BIOS Setup menu
26print"{clear}{down}{purple} {cm asterisk}{reverse on}  {reverse off}{sh pound}{cyan} triangular bios "v$"{return}  {purple}{cm asterisk}{sh pound}{cyan}  (c) 2023{down*2}{return}  {blue}commodore{light blue} plus/4{cyan}  ram:"fm"{left}kb{down}{return}   #: device:         boot/work":cs$="none":ifcs=1thencs$="cbm datasette":
27db=dd:wb=wd:bb=bd:print"   {reverse on}{red}1{cyan}{reverse off}: ":gosub83:fori=.to3
28gosub63:print"  "8+i;"{left}:",:ifdi(i)=.thenprint"{left*4}none"
29ifdi(i)=1thenprint"{left*4}cbm "dt$(i)"{return}","{up}{right*13}{reverse on}{yellow}"(i*2)+1"{left*3}f{right*3}{pink}"(i*2)+2"{left*3}f{reverse off}{cyan}"
30nexti:print"{down}   boot:     work:{return}{down*2}  {reverse on}{red}t{cyan}{reverse off}ime:{return}{down}  {reverse on}{red}r{cyan}{reverse off}eset clock{return}{down*2}  {reverse on}{red}e{cyan}{reverse off}xit {reverse on}{red}s{cyan}{reverse off}ave {reverse on}{red}b{cyan}{reverse off}asic":poke239,.
31gosub57:gosub62:getk$:ifk$=""then31
32ifk$="e"thenprint"{clear}":dd=db:wd=wb:bd=bb:goto2
33ifk$="r"thenti$="000000"
34ifk$="1"thengosub86:gosub83
35ifk$="{f1}"theni=.:gosub58
36ifk$="{134}"theni=.:gosub60
37ifk$="{135}"theni=1:gosub58
38ifk$="{136}"theni=1:gosub60
39ifk$="{137}"theni=2:gosub58
40ifk$="{138}"theni=2:gosub60
41ifk$="{139}"theni=3:gosub58
42ifk$="{f8}"theni=3:gosub60
43ifk$="t"thengosub49
44ifk$="s"then47
45ifk$="b"then96
46goto31

47open1,bd,15,"r0:uos=uos":close1:gosub82:ifen<>63thengosub9:gosub9:goto31
48gosub81:goto95

!- Time change
49gosub98:print"{white} {arrow left} {cyan}type new time":ks$="":kv$="":poke239,.:fori=.to5
50gosub57:gosub62:print"{down}{right*8}{light blue}"kv$"{cyan}":getk$:ifk$=""then50
51as=asc(k$):ifas>47andas<58thenks$=ks$+k$:goto53
52goto50

!- Time change display
53kv$=kv$+k$:ifi=1ori=3thenkv$=kv$+":"
54nexti:gosub98::print"                 ":ti$=ks$:poke239,.:return

!- Draw horizontal line 1
55print"{cm @*40}{return}":return

!- Draw horizontal line 2
56print"{cm t*40}{return}":return

!- Time update > setup
57t$=ti$:t1$=left$(t$,2):t2$=mid$(t$,3,2):t3$=right$(t$,2):print"{home}{down*17}{right*8}"t1$":"t2$":"t3$:return

!- Set Boot drive
58ifpeek(971+i)=1thenbd=8+i:return
59return

!- Set Work drive
60ifpeek(971+i)=1thenwd=8+i:return
61return

!- Boot & Work disk drive update > setup
62print"{home}{down*14}{right*8}{yellow}"bd"{left} ","{left*2}{pink}"wd"{left} {cyan}":return

!- Disk drive database
63di(i)=peek(971+i):dn(i)=peek(975+i):dt$(i)="{left*4}unknown":ifdi(i)=.thenreturn
64ifdn(i)=16thendt$(i)="2040"
65ifdn(i)=76thendt$(i)="1541-ii"
66ifdn(i)=170thendt$(i)="1541"
67ifdn(i)=173thendt$(i)="1571"
68ifdn(i)=108thendt$(i)="1581"
69ifdn(i)=7thendt$(i)="2031"
70ifdn(i)=32thendt$(i)="3040"
71ifdn(i)=169thendt$(i)="4040"
72ifdn(i)=255thendt$(i)="1551"
73ifdn(i)=48thendt$(i)="{left*4}sd2iec"
74return

!- Check disk drives
75t=.:fordi=3to.step-1:gosub12:nextdi:ift=1thenbd=bs
76wd=bd:poke960,bd:poke961,wd:ifbi=.thenee$="   {reverse on}no disk drive!{reverse off}":goto89
77ifbd=.thenee$="   {reverse on}no system disk!{reverse off}":goto89

!- Load uos.cfg
78rn=1:open8,bd,8,"uos.cfg,s,r":close8:gosub82:poke991,1:ifen<>.then89
79open8,bd,8,"uos.cfg,s,r":input#8,v1$,wd$,dd$,gc$,gr$,cg$,tc$,pp$:close8:gosub82:poke997,val(gr$):poke996,val(gc$):poke994,val(cg$):wd=val(wd$):dd=val(dd$):poke989,dd:ifpeek(963+wd)=.thenwd=bd
80poke961,wd:poke995,val(tc$):poke990,val(pp$):goto5

!- Save uos.cfg
81open1,bd,15,"s0:uos.cfg":close1:open8,bd,8,"uos.cfg,w,s":print#8,v$:print#8,wd:print#8,dd:print#8,peek(996):print#8,peek(997):print#8,peek(994)::print#8,peek(995):print#8,peek(990):close8:poke989,dd:poke960,bd:poke961,wd:gosub82:return

!- Read disk error chanell
82open1,bd,15:input#1,en,en$,tr,sc:close1:return

!- Update Datasette status graphic > setup
83ifdd=.thenprint"{home}{down*8}{right*6}none         ":return
84ifdd=1thenprint"{home}{down*8}{right*6}cbm datasette":return
85return

!- Datasette enable On/Off
86ifdd=.thendd=1:return
87ifdd=1thendd=.:return
88return

!- Disk drive error
89print"{home}{down*20}"tab(9)"{red}"ee$"{return}{down*2}{yellow} {reverse on}f1{pink}{reverse off} retry"tab(31)"{red}{reverse on}f8{pink}{reverse off} basic";:poke239,.:gosub10
90getk$:ifk$="{f1}"thenrn=.:print"{home}{down*20}{black}{space*37}":goto4
91ifk$="{f8}"then96
92goto90

!- Draw load
93print"{clear}{down*15}"tab(17)"{cm asterisk}{reverse on}    {reverse off}{sh pound}{return}"tab(18)"{cm asterisk}{reverse on}  {reverse off}{sh pound}{return}"tab(19)"{cm asterisk}{sh pound}{return}{down}{white}"tab(12)"{cm @*16}{return}{white}"tab(11)"{cm m}{reverse on}{blue}{cm m*9}{reverse off}       {white}{cm g}{return}{white}"tab(12)"{cm t*16}{return}{white}{down}"tab(9)"     "l$:return

!- Load sequence
94print"{home}{black}load "q$n$q$","bd:poke239,.:fori=.to5:g=peek(1319+i):poke939+i,g:nexti:poke239,6:new

!- Restaring
95l$="restarting...":print"{yellow}";:gosub93:n$="uos":goto94

!- Shut down
96l$="shut down...":print"{red}";:gosub93:gosub11:goto99

!- Clear Time changer
98gosub62:print"{down}{right*8}       ";:return

!-Restart
99print"{clear}{ct h}{blue}{ct n}":sys65526
